
module Asteroid
  class Instance

    def render_erb(string, env)
      Template.new(:erb, string).render(env)
    end

    def eval_command(cmd)


      return aster_environment.eval(cmd)

      # env ||= template_data
      # cmd = Template.new(:erb, cmd).render(env)
      # cmd, *rest = cmd.split(" ")
      # case cmd.to_sym
      # when :run
      #   command_run(rest.first, env)
      # when :upload
      #   from, to, _ = rest
      #   command_upload(from, to, env)
      # when :"upload-private-key"
      #   name, _ = rest
      #   command_upload_private_key(name, env)
      # when :exec
      #   script = rest.join(" ")
      #   command_exec(script, env)
      # when :config
      #   set_or_get, var, val, _ = rest
      #   command_config(set_or_get, var, val)
      # else
      #   if server.commands[cmd]
      #     command_command(cmd, rest, env)
      #   else
      #   end
      # end
    end

    def template_data
      {
        instance: self, server: server
      }
    end

    def command_command(cmd, args, env)
      raise "Not here"
      env ||= template_data
      command = server.commands[cmd]

      env = if command["args"]
        command["args"].inject({}) do |r, k|
          r[k] = args.shift
          r
        end
      end

      env = template_data.merge({
        args: env
      })

      command["steps"].map do |step|
        eval_command step, env
      end.last
    end

    def command_run_yml_script(yml_script, env = nil)
      env ||= template_data
      filename = File.join(Asteroid::Config.script_dir, '/', yml_script)
      script = File.read(filename)
      yml = Template.new(:erb, script).render(env)
      data = YAML::load yml
      unless data["steps"]
        raise "No steps in #{filenbame}"
      else
        data["steps"].each do |step|
          eval_command step, env
        end
      end
    end

    def aster_environment
      @aster_environment ||= Aster::Environment.new.tap do |e|

        self.server.commands.each_pair do |name, data|
          data = case data
          when Array
            {args: [], steps: data}
          when Object
            data
          else
            raise "Commands should be Arrays or arguments or Objects"
          end
          
          commands = Aster::Parser.new.send :parse_lines, data[:steps]
          e.define_function name, data[:args], commands
        end


        e.define_function :run, [:"..."] do |arguments|
          command_run(arguments.join(' '))
        end

        e.define_function :upload, [:"..."] do |(from, to, _)|
          if command_upload from, to
            "yes"
          else
            "no"
          end
        end

        e.define_function :exec, [:"..."] do |arguments|
          command_exec(arguments.join(' '))
        end
      end    
    end

    def command_run_aster_script(aster_script, env = nil)
      filename = File.join(Asteroid::Config.script_dir, '/', aster_script)
      script = File.read(filename)
      aster_environment.eval script
    end

    def command_run(script_name, env = nil)
      env ||= template_data
      script = Script.named(script_name)

      # touch ssh
      self.ssh

      if script.nil?
        raise "No script named #{script_name}"
      end
      
      # Return early if we're running a script
      if script.yml?
        # TODO: send the fucking script obj
        command_run_yml_script(script_name)
        return 
      elsif script.aster?
        command_run_aster_script(script_name)
        return
      end


      if script.template?
        script.set_data env
      end

      rendered_script = script.render
      puts rendered_script
      puts self.ssh_exec rendered_script
    end

    def command_upload(from, to, env = nil)
      env ||= template_data
      from = FileReference.new(from)

      if from.template?
        from.data = env
      end

      puts from.rendered_filename

      self.scp_upload from.rendered_filename, to
    end

    def command_exec(command, env = nil)
      self.ssh_exec command
    end

    def command_config(set_or_get, var, val)
      if set_or_get.to_s == "set"
        self.config_set(var, val)
      elsif set_or_get == "get"
        self.config_get(var)
      end      
    end

  end
end