

module Asteroid
  class KeyReference
    
    class << self
      def search_paths
        @search_paths ||= []
      end
    end

    def name
      @name
    end

    def initialize(name)
      @name = name

      @public  = nil
      @private = nil

      self.class.search_paths.each do |path|
        if @public.nil?
          key = File.join(path, "#{@name}.pub")
          if File.exists? key
            @public = key
          end
        end

        if @private.nil?
          key = File.join(path, "#{@name}")
          if File.exists? key
            @private = key
          end
        end
      end
    end

    def public
      @public && FileReference.new(@public)
    end

    def private
      @private && FileReference.new(@private)
    end

  end
end

