
require_relative './provider/abstract'
require_relative './provider/digital_ocean'
require_relative './provider/virtual_box'
require_relative './provider/mock'

module Asteroid

  class ProviderProxy

    def method_missing(m, *args, &block)
      Config.providers.map do |p|
        p.send(m, *args, &block)
      end.flatten
    end

  end

  module Provider
    
    def self.all
      ProviderProxy.new
    end

  end

  class Config
    class << self
      attr_accessor :providers
      def providers
        @providers ||= []
      end
    end
  end

end