# :name=>"web-1c5c2972",
# :image_id=>3101918,
# :size_id=>66,
# :region_id=>4,
# :backups_active=>false,
# :ip_address=>"107.170.109.79",
# :private_ip_address=>"10.128.197.52",
# :locked=>false,
# :status=>"active",
# :created_at=>"2014-04-12T20:44:53Z"}

require 'active_support/concern'


module Asteroid
  module Provider
    class Abstract

      def required_instance_attributes
        []
      end

      def initialize(config = {})
        @config = config
      end

      def type
        self.class.type
      end

      def self.type
        self.to_s.split('::').last.underscore.to_sym
      end

      def instances
        []        
      end
      
      def destroy_instance(instance)
      end

      protected

        def require_attribute(o, att, message)
          if o[att].nil?
            raise [
              "Can't create instance on #{instance_name} because #{message}:",
              "Add Add #{att} to your server config .yml\n #{o.inspect}"
              ].join(' ')
          end
        end

    end
  end
end