require 'open-uri'

module Asteroid
  class SSHKey

    attr_accessor :id, :name, :ssh_pub_key

    def initialize(options = {})
      @id = options[:id]
      @name = options[:name]
    end

    def exists?
      names = self.class.all.map{|k| k.name }
      names.include? @name
    end

    def self.find(name)
      name = name.to_s
      all.select{|k| k.name == name}.first
    end

    def self.all
      keys = Provider.all.ssh_keys
      keys.map do |key|
        new id: key[:id], name: key[:name]
      end
    end

    def save
      if exists?
        puts "Key exists"
      else 
        Digitalocean::SshKey.create(
          name: @name, 
          ssh_pub_key: URI::escape(@ssh_pub_key)
        )
      end
    end
  end
end