require 'erb'

module Asteroid
  class Template

    attr_accessor :text

    def initialize(type = :erb, text = nil)
      @type = type
      @text = text
    end

    def render(locals = {})
      render_text(@text, locals)
    end

    def render_text(text = nil, locals = {})
      m = "render_#{@type}"
      if Asteroid::Config.template_engines[@type]
        self.send m, text, locals
      else
        raise "No template engine for type #{@type}"
      end
    end

    private

      def render_erb(text, locals = {})
        ERB.new(text).result(
          data = OpenStruct.new(locals).instance_eval{ binding }
        )
      end
      
  end
end

Asteroid::Config.template_engines[:erb] = Asteroid::Template